<template>
  <div class="vertical-menu-panel flex-grow-0 flex-column" v-bind:class="displayClass">
    <!-- not minimized -->
    <div v-if="!minimized" class="d-flex flex-grow-1 flex-column">
      <!-- title area -->
      <div class="bg-primary d-flex flex-row py-3">
        <h1 class="text-light my-0 py-2 px-3 flex-grow-1">
          <span class="mr-2">
            <font-awesome-icon icon="layer-group"></font-awesome-icon>
          </span>
          {{ title }}
        </h1>
        <button class="btn text-light flex-grow-0 mr-2 close-btn" @click="minimized = true">
          <font-awesome-icon icon="angle-left"></font-awesome-icon>
        </button>
        <button class="btn text-light flex-grow-0 mr-2 close-btn" @click="close">
          <font-awesome-icon icon="times"></font-awesome-icon>
        </button>
      </div>

      <div class="d-flex flex-grow-1 flex-row">
        <!-- layer groups -->
        <div class="layer-group-list d-flex flex-grow-1 flex-column bg-light">
          <div v-for="group in layerGroups()" :key="group.layerGroupProxyId">
            <button class="btn btn-light btn-block text-left"
              :class="isActiveGroup(group.id)"
              @click="currentGroup = group.id">
              {{ group.title }}
            </button>
          </div>
        </div>
        <!-- layer for group -->
        <div class="layer-list d-flex flex-grow-1 flex-column px-2 py-2">
          <layer-checkbox v-for="layer in currentLayers()" :key="layer.layerProxyId"
            :identifier="layer.layerProxyId"
            :icon="layer.icon">
          </layer-checkbox>
        </div>
      </div>
    </div>

    <!-- minimized -->
    <div v-else class="d-flex flex-grow-1 flex-column">
      <div class="bg-primary d-flex flex-row py-3">
        <button class="btn text-light flex-grow-0 mx-auto close-btn" @click="minimized = false">
          <font-awesome-icon icon="layer-group"></font-awesome-icon>
        </button>
      </div>

      <div class="d-flex flex-grow-1 flex-row">
        <div class="layer-list-minimized d-flex flex-grow-1 flex-column px-2 py-2">
          <layer-checkbox v-for="layer in currentLayers" :key="createUniqueId(layer)"
            :identifier="layer.layerProxyId"
            :icon="layer.icon"
            :notext="true">
          </layer-checkbox>
        </div>
      </div>
    </div>

  </div>
</template>

<script>
import LayerCheckbox from '@/dashboard/components/layers/LayerCheckbox'
import { SET_WORKSPACE_CURRENT_PANEL } from '@/store'

export default {
  name: 'layerverticalpanel',

  props: {
    title: {
      type: String,
      default: 'Camadas',
    },

    name: {
      type: String,
      required: true,
    },
  },

  data() {
    return {
      minimized: false,
      currentGroup: null,
    }
  },

  computed: {
    workspace: {
      get() {
        return this.$parent.workspace
      }
    },

    currentPanel: {
      get() {
        return this.$store.getters.workspaceCurrentPanel(this.workspace)
      }
    },

    displayClass: {
      get() {
        return this.currentPanel === this.name ? 'd-flex' : 'd-none'
      }
    },
  },

  methods: {
    close() {
      this.$store.commit(SET_WORKSPACE_CURRENT_PANEL, {
        workspaceId: this.workspace,
        panel: null,
      })
    },

    layerGroups() {
      return Object.values(this.$store.getters.workspaceLayerGroups(this.workspace)).sort((a, b) => {
        if(a.title < b.title) return -1
        if(a.title > b.title) return 1
        return 0
      })
    },

    currentLayers() {
      return Object.values(this.$store.getters.workspaceLayers(this.workspace)).filter(layer => {
        return layer.groups.includes(this.currentGroup)
      }).sort((a, b) => {
        if(a.title < b.title) return -1
        if(a.title > b.title) return 1
        return 0
      })
    },

    isActiveGroup(group) {
      return group === this.currentGroup
    },
  },

  created() {
    this.currentGroup = this.layerGroups()[0].id
  },

  components: {
    LayerCheckbox
  },
}
</script>
